;    144-146  
;    144-146   25 
;    133,3-135,3  (  10,7 )
;     Repiter 133,9-135,9 
; 36   EEPROM
;4   (32-35)
;  RB0,RB1
; :  -  (), L -  (RX)  RB2
;
;
;  ..
;18  2005
;
;
;  
;
;
;
;
;
	list      p=16F84
	#include  <p16F84.inc>

      __CONFIG   _CP_OFF & _WDT_ON & _PWRTE_ON & _XT_OSC
    
;  ---------

SensPos	equ	22h	;  
Count	equ	0dh	; 
Count2	equ	0eh	; 
Count3	equ	2fh
D00     equ     19h
Digit0	equ	18h	;   
Digit1	equ	17h     ;/
Digit2	equ	16h     ;
Digit3	equ	15h     ;
Digit4	equ	14h  
Digit5  equ     13h
D01     equ     12h     ;  
C0      equ     11h     ;
C1      equ     10h
D02     equ     0fh
FreqL	equ	1ch	;  
FreqH	equ	1bh	;   
IFL	equ	2ch	;  
IFH	equ	2bh	;
Fm_number      equ  1ah ; 
IFm	equ	2ah
DF	equ	2dh	; (f-44,000 )
Divisor_high   equ  1eh ;  
Divisor_low    equ  1fh ;  
Dtemp   equ     1dh
Flag	equ	3fh	;0-'L'/'H' 2-/ 3- /
th	equ	20h	;  
Count4  equ	21h
BUTTONS	equ	23h	; 
Bufer	equ	24h

; -----------------

SENSORS	equ	PORTB
SEN1	equ	01H
SEN2	equ	02H
SENS	equ	03H	; 
Pos0	equ	0
Pos1	equ	SEN1
Pos2	equ	SENS
Pos3	equ	SEN2
BUTS	equ	0xf0	; 
ButU	equ	0xE0	;
ButD	equ	0xD0	;
ButF	equ	0xB0	;  
ButC	equ	0x70	;  (   )
Byt3    equ     0xA0	;  LM7001 (FM,  25 )
D_h_s	equ	16h
D_l_s	equ	80h	;   144 
D_h_p	equ	14h
D_l_p	equ	0xD7	;   133,3 
D_h_r	equ	14h
D_l_r	equ	0xEC	;    133,9  


; 

JZ	macro	LBL
	btfsc	STATUS,Z
	goto	LBL
	endm
CJZ	macro	LBL
	btfsc	STATUS,Z
	call	LBL
	endm
NODE	macro	pp1,nn1,pp2,nn2,pp3,nn3
	local	N0
N0	movfw	SENSORS
	movwf	BUTTONS
	andlw	SENS
	movwf	SensPos
	xorlw	pp1
	JZ	nn1
	movfw	SensPos
	xorlw	pp2
	JZ	nn2
	movfw	SensPos
	xorlw	pp3
	JZ	nn3
	call	BTN
	clrWDT
	goto	N0
	endm

    org 0x00
reset goto start
    org 0x04

outsim  addwf  PCL,f	;  
        retlw  0xee ;0     
        retlw  0x60 ;1
        retlw  0x2f ;2
        retlw  0x6d ;3
        retlw  0xe1 ;4
        retlw  0xcd ;5
        retlw  0xcf ;6
        retlw  0x68 ;7
        retlw  0XEF ;8
        retlw  0xed ;9
        retlw  0x00 ;
        retlw  0x01 ;-
        retlw  0x08 ;^
        retlw  0x43 ;

start	movlw 0x88         ; 
	movwf FreqL        ;
	movlw 0x13         ;
	movwf FreqH        ;5,000 
	movlw	.1         ;
	movwf	Digit5	   ;	
	movlw	.4	   ;
	movwf	Digit4	   ;140 
	movlw   20h        ;
	movwf Fm_number    ;32 

	movlw 0xA8		;    
 	movwf Divisor_low	;145,000/0,025=5800=0x16A8
 	movlw 0x16		;
 	movwf Divisor_high 	;
	movlw	0x28		;
	movwf	DF		;
	
    clrf PORTA         ; 107
    clrf PORTB
    bsf STATUS,RP0
    movlw 0x00
    movwf PORTA
    movlw 0x0f
    movwf PORTB
    bcf STATUS,RP0
    bcf   PORTA,1        ;
    movlw 0xf0           ; 
    call  st1
    movlw 0x10
    call  st
    call RDeepromC
    call RDeeprom
	clrf	Flag
	btfsc	Fm_number,5	; 32-35 
	bsf	Flag,3		; repit
	btfss	Fm_number,5	; 0-31 
	bcf	Flag,3		; 
	call	Fg
	call	Fi		;!!!!!!!!!!!!!
	call show
HELP	nop
ND0			;NODE	Pos1,ND1,Pos3,ND4,Pos2,ND0
	movfw	SENSORS
	movwf	BUTTONS
	andlw	SENS
	movwf	SensPos
	xorlw	01h
	JZ	ND1
	movfw	SensPos
	xorlw	02h
	JZ	ND4
	call	BTN
	clrWDT
	goto	ND0
ND1	NODE	Pos2,ND2,Pos0,ND0,Pos3,ND0
ND2	NODE	Pos3,ND3,Pos1,ND1,Pos0,ND0
ND3	NODE	Pos0,ND3A,Pos2,ND2,Pos1,ND0
ND3A	call	mUp0	;+1
	goto	ND0
ND4	NODE	Pos2,ND5,Pos0,ND0,Pos1,ND0
ND5	NODE	Pos1,ND6,Pos3,ND4,Pos0,ND0
ND6	NODE	Pos0,ND6S,Pos2,ND5,Pos3,ND0
ND6S	call	mDown0	;-1
	goto	ND0

BTN	movlw	0bh
	movwf	th
	movlw	05h
	movwf	Count4
	movfw	BUTTONS
	andlw	b'00000100'	;  
	xorwf	Flag,W		; \?
	movwf	Bufer
	btfss	Bufer,2		;
	goto	btn1		;
	btfsc	BUTTONS,2	; 
	bsf	Flag,2		;
	btfss	BUTTONS,2	;
	bcf	Flag,2		;
	call	Fi
	call	Fg
	call	show
	clrWDT
btn1	movfw	BUTTONS
	andlw	BUTS
	movwf	BUTTONS
	xorlw	ButU
	CJZ	mUp
	movfw	BUTTONS
	xorlw	ButD
	CJZ	mDown
	movfw	BUTTONS
	xorlw	ButF
	CJZ	mF
	movfw	BUTTONS
	xorlw	ButC
	CJZ	mC
	return
mUp	btfsc	Flag,0
	goto	Up1
	btfss	Flag,0
	goto	Up
mDown	btfsc	Flag,0
	goto	Down1
	btfss	Flag,0
	goto	Down
mUp0	btfsc	Flag,0
	goto	Up10
	btfss	Flag,0
	goto	Up
mDown0	btfsc	Flag,0
	goto	Down10
	btfss	Flag,0
	goto	Down
mC	btfsc	Flag,0	;
	call	WReeprom
	btfss	Flag,0
	call	WReeprom
	bcf	Flag,0
	goto	mF1
mF	bsf	Flag,0	;
mF1	call	Fi
	call	Fg
	call	show
	call time1
	clrWDT
	return
Down
    	call time1
    decf	Fm_number,f
    movfw	Fm_number
    sublw 0xff
    btfss STATUS,2
    goto   ChangeCanal
    movlw 23h
    movwf Fm_number
    goto   ChangeCanal
Up
    	call time1
    incf	Fm_number,f
    movfw	Fm_number
    sublw 0x24
    btfsc STATUS,2
    clrf	Fm_number
ChangeCanal
	btfsc	Fm_number,5	; 32-35 
	bsf	Flag,3		; repit
	btfss	Fm_number,5	; 0-31 
	bcf	Flag,3		; 
    call RDeeprom
	call	Fi	
	call	Fg
    call show
    return 
Down1	call time
Down10	decf	DF,f   
	movfw	DF
	sublw 0xff		;  F
	btfss STATUS,2
	goto	ChangeFreq
	movlw	50h
	movwf	DF
	movlw	0x70
	movwf	FreqL
	movlw	0x17
	movwf	FreqH
	goto   ChangeFreq
Up1	call time
Up10	incf	DF,f 
	movf	DF,w        
	sublw	51h		;  F
	btfss	STATUS,2
	goto	ChangeFreq
	clrf	DF
	movlw	0xA0
	movwf	FreqL
	movlw	0x0F
	movwf	FreqH
ChangeFreq
	call	Fi
	call  show
	clrWDT
	movf	Count4,f
	btfss	STATUS,2
	decf	Count4,f
	btfss	STATUS,2
	goto	aa
        movlw	01h	; 
        subwf    th,W	
	btfss	STATUS,2
	decf	th,f
aa    btfss PORTB,4
      goto Up1
      btfss PORTB,5
      goto Down1
      return

time     
         movlw	 0xff
         movwf   Count2
         movf    th,W
         movwf   Count
t        decf    Count2,f
         btfsc   STATUS,2
         decf    Count,f
         btfsc   STATUS,2
         return
         goto    t

time1     
         movlw	 0xff
         movwf   Count2
         movlw	 0x0B
         movwf   Count
t1        decf    Count2,f
         btfsc   STATUS,2
         decf    Count,f
         btfsc   STATUS,2
         return
         goto    t1

Bin2LCD ; 2-x     -
	movf	FreqH,w
	movwf	IFH
	movf	FreqL,w
	movwf	IFL
	bcf        STATUS,0
        movlw      .16
        movwf      Count
	clrf       Digit4
        clrf       Digit3
        clrf       Digit2
        clrf       Digit1
        clrf       Digit0
loop16
        rlf        FreqL,f
        rlf        FreqH,f
        rlf        Digit0,f
        rlf        Digit1,f
        rlf        Digit2,f
        rlf        Digit3,f
        rlf        Digit4,f
        decfsz     Count,f
        goto       adjDEC
        movfw      Digit4
        andlw      0Fh
        swapf      Digit3,w
        andlw      0Fh
        movfw      Digit3
        andlw      0Fh
        swapf      Digit2,w
        andlw      0Fh
        movfw      Digit2
        andlw      0Fh
        movwf      Digit4
        swapf      Digit1,w
        andlw      0Fh
        movwf      Digit3
        movfw      Digit1
        andlw      0Fh
        movwf      Digit2
        swapf      Digit0,w
        andlw      0Fh
        movwf      Digit1
        movfw      Digit0
        andlw      0Fh
        movwf      Digit0
        movf    IFH,w 
	movwf  	FreqH
	movf	IFL,w
	movwf	FreqL
        return
adjDEC
        movlw      Digit0
        movwf      FSR
        call       adjBCD
        movlw      Digit1
        movwf      FSR
        call       adjBCD
        movlw      Digit2
        movwf      FSR
        call       adjBCD
        movlw      Digit3
        movwf      FSR
        call       adjBCD
        movlw      Digit4
        movwf      FSR
        call       adjBCD
        goto       loop16
adjBCD
        movlw      3
        addwf      0,w
        movwf      Count2
        btfsc      Count2,3
        movwf      0
        movlw      30
        addwf      0,w
        movwf      Count2
        btfsc      Count2,7
        movwf      0
        retlw      0
BCD   ; 1 a    -
	movf	Fm_number ,w
	movwf	IFm
	bcf        STATUS,0
        movlw      .8
        movwf      Count
        clrf       C1
        clrf       C0
loop8
        rlf        Fm_number,f
        rlf        C0,f
        rlf        C1,f
        decfsz     Count,f
        goto       adjDEC1
        movfw      C1
        andlw      0Fh
        movwf      D02
        swapf      C0,w
        andlw      0Fh
        movwf      C1
        movfw      C0
        andlw      0Fh
        movwf      C0
         movf 	IFm,w 
        movwf	Fm_number
        return
adjDEC1
        movlw      C0
        movwf      FSR
        call       adjBCD1
        movlw      C1
        movwf      FSR
        call       adjBCD1
        movlw      D02
        movwf      FSR
        call       adjBCD1
        goto       loop8
adjBCD1
        movlw      3
        addwf      0,w
        movwf      Count2
        btfsc      Count2,3
        movwf      0
        movlw      30
        addwf      0,w
        movwf      Count2
        btfsc      Count2,7
        movwf      0
        retlw      0
RDeepromC                          ;  EEPROM
       bcf         STATUS,5	   ; 
	movlw	0x3f
       movwf       EEADR
       bsf         STATUS,5
       bsf         EECON1,RD
       bcf         STATUS,5
       movf        EEDATA,W
          btfsc    EEDATA,7
          return
       movwf       Fm_number
          return
RDeeprom                           ;  EEPROM
       bcf         STATUS,5	   ;
       movf        Fm_number,W
       movwf       EEADR
       bsf         STATUS,5
       bsf         EECON1,RD
       bcf         STATUS,5
       movf        EEDATA,W
          btfsc    EEDATA,7
          return
       movwf       DF
       return
WReeprom   ;  EEPROM  
	movf      DF,w		
	movwf   EEDATA		
	movf    Fm_number,w
	movwf   EEADR
	call	write
        return
WReeprom   ;  EEPROM   
	movf    Fm_number,w		
	movwf   EEDATA		
	movlw	3fh    
	movwf   EEADR
	call	write
	return
write                     ;  EEPROM.
	bsf	STATUS,RP0
        ;bcf     INTCON,GIE
	bsf	EECON1,WREN	; 
	bcf	EECON1,EEIF
	movlw	055h
	movwf	EECON2
	movlw	0AAh
	movwf	EECON2
        ;bsf     INTCON,GIE
	bsf	EECON1,WR
wee    	btfsc	EECON1,WR	;  
	goto	wee
	bcf	EECON1,WREN	; 
        bcf	STATUS,RP0
	return
show	call BCD
	call Bin2LCD
	movlw	.1
	movwf	Digit5	   ;	
	movlw	.4	   ;
	movwf	Digit4	   ;140 
	btfsc	Flag,0
	goto show2
show1           ;  107   "" 
        movlw   0x0a
        movwf   D00
        movwf   D01
        goto	show0
show2   	;  107   ""
        movlw   0x0a
        movwf   D01
        movlw   0x0b 
        movwf   D00
show0	btfsc	Flag,3
	movlw	0x0C
        movwf   D00
	btfss	Flag,2
	goto	sh3
	movlw	0x0D
        movwf   D01
sh3    clrf PORTB
    bsf STATUS,RP0
    movlw 0x00
    movwf PORTA
    movlw 0x0f
    movwf PORTB
    bcf STATUS,RP0       
        movf    C1,w
        btfsc   STATUS,2
        call    nolC1
        movlw   C1      ;    
        movwf   FSR
        movlw   0X0A
        movwf   Count 
nextk   movf    INDF,w
        call    outsim    ; 
        movwf   INDF
        incf    FSR,f
        decfsz    Count,f
        goto    nextk
        bsf     Digit3,4  ;
	btfsc	Flag,0
	bsf	Digit5,0  ;   ""
	btfsc	Flag,0
	bsf	D00,0  	;   ""
    bcf   PORTA,1         ;
    movlw 0x00            ;
    call  st1
        movlw   C1        ;    107
        movwf   FSR
        movlw   0X0A
        movwf   Count
nexto   swapf   INDF,w
        call    st
        movf    INDF,w
        call    st
        incf    FSR,f
        decfsz    Count,f
        goto    nexto

;   LM7001
        bsf     PORTA,2
        movf    Divisor_low,w
        movwf   Dtemp
        call    outbyte
        movf    Divisor_high,w
        movwf   Dtemp
        call    outbyte
        movlw   Byt3
        movwf   Dtemp
        call    outbyte
        bcf     PORTA,2
    clrf PORTB           ;  
    bsf STATUS,RP0	; 
    movlw 0xF7
    movwf PORTB
    bcf OPTION_REG,7
    bcf STATUS,RP0
    return
st   ;   107
        bsf   PORTA,1        ;
st1     bsf   PORTA,0        ;
        nop
        movwf   PORTB
        nop       
        bcf   PORTA,0
        nop       
        bsf   PORTA,0
    return
nolC1
    movlw 0x0a
    movwf C1
    return

outbyte
        movlw 0x08
        movwf Count
ob      bcf   PORTA,4
        rrf   Dtemp,f
        btfsc STATUS,0
        bsf   PORTA,4
        nop
        bsf   PORTA,3
        nop
        bcf   PORTA,3
        decf  Count,f
        btfsc STATUS,2
        return       
        goto ob       
;  
Fg     	btfsc	Flag,2
	goto	Fgsend
	btfsc	Flag,3
	goto	Fgr
	goto	Fgp	
Fgsend	movlw   D_h_s		;     
	movwf   Divisor_high
	movlw	D_l_s
        movwf   Divisor_low
	goto	FG
Fgp	movlw   D_h_p		;     
	movwf   Divisor_high
	movlw	D_l_p
        movwf   Divisor_low
	goto	FG
Fgr	movlw   D_h_r		;    
	movwf   Divisor_high
	movlw	D_l_r
        movwf   Divisor_low
FG      movfw   DF		
        addwf   Divisor_low,f
        btfsc   STATUS,0
        incf    Divisor_high,f
	return
Fi	movlw	0x0F
	movwf	FreqH
	movlw	0xA0
	movwf	FreqL
	movlw	0x19		; 
	movwf	Count		; 
	movfw	DF		
Fi1	addwf	FreqL,f		;DF*25     	
        btfsc	STATUS,0	  	
        incf	FreqH,f
	decf	Count,f
	btfsc	STATUS,2
	return
	goto	Fi1


; ORG  0x2100  ;  
          


      end







